#ifndef STORMDEBUG_H
#define STORMDEBUG_H

#include <stdlib.h>

typedef struct DebugSymbol
{
  struct DebugSymbol *next;
  char *name;
  unsigned int value;
  int desc;
  int type;
  int hunknumber;

  struct Section *section;
} symbolS;

#define symbol_next(sym) (sym->next)
#define S_GET_NAME(sym) (sym->name)
#define S_GET_VALUE(sym) (sym->value)
#define S_GET_DESC(sym) (sym->desc)
#define S_GET_TYPE_FULL(sym) (sym->type)
#define S_GET_HUNKNO(sym) (sym->hunknumber)

extern void *alloc(size_t);
#define xmalloc alloc
#define xfree free

void debug_output(char *fname, symbolS *first);

#endif  /* STORMDEBUG_H */
